/*
 * VXPLib COMPONENT
 *
 * Module: AboutBox.h - About Box of the component;
 *
 * Synopsis: The dialog box contains legal and version
 * notices about the component.
 *
 * Copyright (c) 2002, Vitaly Tomilov
 * Copyright (c) 2003-2005, Tooltips.Net L.L.C.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Library support web site - http://www.tooltips.net
 */

#if !defined(AFX_ABOUTBOX_H__43FEA7B2_CE21_4369_8709_EE33E9DA04E0__INCLUDED_)
#define AFX_ABOUTBOX_H__43FEA7B2_CE21_4369_8709_EE33E9DA04E0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "atlwin.h"
#include "resource.h"
#include "size.h"
#include "Timer.h"

class CAboutBox: public CSimpleDialog<IDD_ABOUTBOX, TRUE>
{
public:
	CAboutBox();
	virtual ~CAboutBox();

protected:
	LRESULT OnPaint(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL & bHandled);
	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL & bHandled);
	LRESULT OnOK(WORD wNotifyCode, WORD wID, HWND hWndCtrl, BOOL & bHandled);
	LRESULT OnCancel(WORD wNotifyCode, WORD wID, HWND hWndCtrl, BOOL & bHandled);
	LRESULT OnVXPTimer(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL & bHandled);
	LRESULT OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

BEGIN_MSG_MAP(CAboutBox)
	MESSAGE_HANDLER(WM_PAINT, OnPaint)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	MESSAGE_HANDLER(WM_VXPTIMER, OnVXPTimer)
	MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
	COMMAND_ID_HANDLER(IDOK, OnOK)
	COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
END_MSG_MAP()

private:
	
	UINT m_Fade;
	CSize m_size;
	IVXPQuickHTML * m_pHTML;
	typedef BOOL (WINAPI* FN_SET_LAYERED_WINDOW_ATTRIBUTES)(HWND,COLORREF,BYTE,DWORD);
	FN_SET_LAYERED_WINDOW_ATTRIBUTES m_fnSetLayeredWindowAttributes;
};

#endif // !defined(AFX_ABOUTBOX_H__43FEA7B2_CE21_4369_8709_EE33E9DA04E0__INCLUDED_)
