/*
 * VXPLib COMPONENT
 *
 * Module: Size.cpp - Implementation of classes CSize and CRect
 *
 * Synopsis: Two simple C++ objects for everyday life
 * CRect and CSize :-)
 *
 * Copyright (c) 2002, Vitaly Tomilov
 * Copyright (c) 2003-2005, Tooltips.Net L.L.C.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Library support web site - http://www.tooltips.net
 */

#include "stdafx.h"
#include "Size.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CSize::CSize()
{
	Zero();
}

CSize::CSize(int x, int y)
{
	cx = x;
	cy = y;
}

CSize::~CSize()
{

}

void CSize::Zero()
{
	cx = 0;
	cy = 0;
}

CSize & CSize::operator += (CSize & object)
{
	cx += object.cx;
	cy += object.cy;
	return *this;
}

void CSize::SetSize(int x, int y)
{
	cx = x;
	cy = y;
}

void CSize::SetSize(CSize & s)
{
	cx = s.cx;
	cy = s.cy;
}

bool CSize::IsEmpty()
{
	return (!cx || !cy);
}

void CSize::AdjustToMax(CSize &s)
{
	cx = max(cx, s.cx);
	cy = max(cy, s.cy);
}

bool CSize::operator != (CSize & object)
{
	return (cx != object.cx || cy != object.cy);
}

/////////////////////////////////////////////////////
// CRect class implementation
/////////////////////////////////////////////////////

CRect::CRect()
{
	left = 0;
	top = 0;
	right = 0;
	bottom = 0;
}

CRect::CRect(int l, int t, int r, int b)
{
	left = l;
	top = t;
	right = r;
	bottom = b;
}
