/*
 * VXPLib COMPONENT
 *
 * Module: Size.h - Declaration of classes CSize and CRect
 *
 * Synopsis: Two simple C++ objects for everyday life
 * CRect and CSize :-)
 *
 * Copyright (c) 2002, Vitaly Tomilov
 * Copyright (c) 2003-2005, Tooltips.Net L.L.C.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Library support web site - http://www.tooltips.net
 */

#if !defined(AFX_SIZE_H__C5C6B210_6570_4CC5_AFA2_547B4883F544__INCLUDED_)
#define AFX_SIZE_H__C5C6B210_6570_4CC5_AFA2_547B4883F544__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CSize  
{
public:
	// Constructors:
	CSize();
	CSize(int x, int y);
	// Destructor:
	virtual ~CSize();

	void AdjustToMax(CSize & s);
	void SetSize(int x, int y);
	void SetSize(CSize&);

	void Zero();
	bool IsEmpty();

	CSize & operator += (CSize & object);
	bool operator != (CSize & object);

	int cx;
	int cy;
};

class CRect:public RECT
{
public:
	// Constructors:
	CRect();
	CRect(int l, int t, int r, int b);
	// Destructor:
	virtual ~CRect(){}
	// Type operator:
	operator LPRECT (){return this;}
};

#endif // !defined(AFX_SIZE_H__C5C6B210_6570_4CC5_AFA2_547B4883F544__INCLUDED_)
