/*
 * VXPLib COMPONENT
 *
 * Module: TOFont.h - Declarations of QHTML tag classes to work with
 * fonts;
 *
 * Synopsis: This file contains declarations of all classes
 * that implement font-related tag objects of QHTML syntax.
 *
 * Copyright (c) 2002, Vitaly Tomilov
 * Copyright (c) 2003-2005, Tooltips.Net L.L.C.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Library support web site - http://www.tooltips.net
 */

#if !defined(AFX_TOFONT_H__A23906D5_4678_4BD6_9571_FF9ADE7C76F0__INCLUDED_)
#define AFX_TOFONT_H__A23906D5_4678_4BD6_9571_FF9ADE7C76F0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "TagObject.h"
#include "GlobalObject.h"
#include "VXPLib.h"

class CTOFont : public CTagObject  
{
public:
	CTOFont(CTag * tag, CGlobalObject * globalObject);
protected:
	virtual void OnDrawTag(HDC dc, int x, int y, int width, int height, int ZeroX, int ZeroY);
	virtual CSize GetSize(HDC);
private:
	void RetrieveCharSet(CTag * tag);
	LOGFONTEX SetupLogFont(HDC dc);
	CGlobalObject * m_pGlobalObject;
	int m_uSize;
	int m_SizeSign;
	CString m_strFace;
	int m_uWeight;
	bool m_bColorValid;
	bool m_bBGColorValid;
	COLORREF m_TextColor;
	COLORREF m_TextBkColor;
	BYTE m_CharSet;
	bool m_bHasCharSet;
};

class CTOFontEnd : public CTagObject  
{
public:
	CTOFontEnd(CGlobalObject * globalObject);
protected:
	virtual void OnDrawTag(HDC dc, int x, int y, int width, int height, int ZeroX, int ZeroY);
	virtual CSize GetSize(HDC);
private:
	CGlobalObject * m_pGlobalObject;
};

class CTOBold : public CTagObject  
{
public:
	CTOBold(CTag * tag, CGlobalObject * globalObject);
protected:
	virtual void OnDrawTag(HDC dc, int x, int y, int width, int height, int ZeroX, int ZeroY);
	virtual CSize GetSize(HDC);
private:
	CGlobalObject * m_pGlobalObject;
};

class CTOStrike : public CTagObject  
{
public:
	CTOStrike(CTag * tag, CGlobalObject * globalObject);
protected:
	virtual void OnDrawTag(HDC dc, int x, int y, int width, int height, int ZeroX, int ZeroY);
	virtual CSize GetSize(HDC);
private:
	CGlobalObject * m_pGlobalObject;
};

class CTOItalic : public CTagObject  
{
public:
	CTOItalic(CTag * tag, CGlobalObject * globalObject);
protected:
	virtual void OnDrawTag(HDC dc, int x, int y, int width, int height, int ZeroX, int ZeroY);
	virtual CSize GetSize(HDC);
private:
	CGlobalObject * m_pGlobalObject;
};

class CTOUnderline : public CTagObject  
{
public:
	CTOUnderline(CTag * tag, CGlobalObject * globalObject);
protected:
	virtual void OnDrawTag(HDC dc, int x, int y, int width, int height, int ZeroX, int ZeroY);
	virtual CSize GetSize(HDC);
private:
	CGlobalObject * m_pGlobalObject;
};

class CTOBoldEnd : public CTagObject
{
public:
	CTOBoldEnd(CGlobalObject * globalObject);
protected:
	virtual void OnDrawTag(HDC dc, int x, int y, int width, int height, int ZeroX, int ZeroY);
	virtual CSize GetSize(HDC);
private:
	CGlobalObject * m_pGlobalObject;
};

class CTOStrikeEnd : public CTagObject
{
public:
	CTOStrikeEnd(CGlobalObject * globalObject);
protected:
	virtual void OnDrawTag(HDC dc, int x, int y, int width, int height, int ZeroX, int ZeroY);
	virtual CSize GetSize(HDC);
private:
	CGlobalObject * m_pGlobalObject;
};

class CTOItalicEnd : public CTagObject
{
public:
	CTOItalicEnd(CGlobalObject * globalObject);
protected:
	virtual void OnDrawTag(HDC dc, int x, int y, int width, int height, int ZeroX, int ZeroY);
	virtual CSize GetSize(HDC);
private:
	CGlobalObject * m_pGlobalObject;
};

class CTOUnderlineEnd : public CTagObject
{
public:
	CTOUnderlineEnd(CGlobalObject * globalObject);
protected:
	virtual void OnDrawTag(HDC dc, int x, int y, int width, int height, int ZeroX, int ZeroY);
	virtual CSize GetSize(HDC);
private:
	CGlobalObject * m_pGlobalObject;
};

#endif // !defined(AFX_TOFONT_H__A23906D5_4678_4BD6_9571_FF9ADE7C76F0__INCLUDED_)
