/*
 * VXPLib COMPONENT
 *
 * Module: ToolList.cpp - Implementation of class CToolList and its
 * two derivatives: CToolWndList and CToolCmdList
 *
 * Synopsis: Class CToolList is a collection of tooltip objects 
 * (QHTML documents) that can be attached to any type of objects,
 * whilst classes CToolWndList and CToolCmdList implement attaching
 * tooltips using Window Handle and Command ID correspondingly.
 *
 * Copyright (c) 2002, Vitaly Tomilov
 * Copyright (c) 2003-2005, Tooltips.Net L.L.C.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Library support web site - http://www.tooltips.net
 */

#include "stdafx.h"
#include "vxplib.h"
#include "ToolList.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CToolList::CToolList(BSTR text)
{
	m_bActive = true;
	m_text = text;
}

///////////////////////////////////////////////////////////////////////
// CToolCmdList class
///////////////////////////////////////////////////////////////////////

CToolCmdList::CToolCmdList()
{
	m_ID = 0;
}

CToolCmdList::CToolCmdList(UINT ID, BSTR text) : CToolList(text)
{
	m_ID = ID;
}

///////////////////////////////////////////////////////////////////////
// CToolWndList class
///////////////////////////////////////////////////////////////////////

CToolWndList::CToolWndList()
{
	m_hWnd = NULL;
}

CToolWndList::CToolWndList(HWND hWnd, BSTR text) : CToolList(text)
{
	m_hWnd = hWnd;
}
