/*
 * VXPLib COMPONENT
 *
 * Module: ToolList.h - Declaration of class CToolList and its
 * two derivatives: CToolWndList and CToolCmdList
 *
 * Synopsis: Class CToolList is a collection of tooltip objects 
 * (QHTML documents) that can be attached to any type of objects,
 * whilst classes CToolWndList and CToolCmdList implement attaching
 * tooltips using Window Handle and Command ID correspondingly.
 *
 * Copyright (c) 2002, Vitaly Tomilov
 * Copyright (c) 2003-2005, Tooltips.Net L.L.C.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Library support web site - http://www.tooltips.net
 */

#if !defined(AFX_TOOLLIST_H__D63A02B2_1B16_42AA_ABAF_F0068DB7D52E__INCLUDED_)
#define AFX_TOOLLIST_H__D63A02B2_1B16_42AA_ABAF_F0068DB7D52E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "HCollection.h"
#include "String.h"

class CToolList : public HCollection
{
public:
	CToolList():m_bActive(true){};
	CToolList(BSTR text);

	virtual ~CToolList(){};
	
	bool m_bActive;

	CString m_text;
};

class CToolWndList : public CToolList
{
public:
	CToolWndList();
	CToolWndList(HWND hWnd, BSTR text);

	HWND m_hWnd;
};

class CToolCmdList : public CToolList
{
public:
	CToolCmdList();
	CToolCmdList(UINT ID, BSTR text);

	long m_ID;
};

#endif // !defined(AFX_TOOLLIST_H__D63A02B2_1B16_42AA_ABAF_F0068DB7D52E__INCLUDED_)
