/*
 * VXPLib COMPONENT
 *
 * Module: VXPCmdToolList.h - Declaration of class CVXPCmdToolList
 *
 * Synopsis: Class CVXPCmdToolList implements methods and properties
 * of interface IVXPCmdToolList.
 *
 * Copyright (c) 2002, Vitaly Tomilov
 * Copyright (c) 2003-2005, Tooltips.Net L.L.C.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Library support web site - http://www.tooltips.net
 */

#ifndef __VXPCMDTOOLLIST_H_
#define __VXPCMDTOOLLIST_H_

#include "resource.h"       // main symbols
#include "ToolList.h"

class CVXPTooltipManager;

/////////////////////////////////////////////////////////////////////////////
// CVXPCmdToolList
class ATL_NO_VTABLE CVXPCmdToolList : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CVXPCmdToolList, &CLSID_VXPCmdToolList>,
	public IDispatchImpl<IVXPCmdToolList, &IID_IVXPCmdToolList, &LIBID_VXPLibrary>,
	public CVXPException<&CLSID_VXPCmdToolList, &IID_IVXPCmdToolList>
{
public:
	CVXPCmdToolList()
	{
		m_pManager = NULL;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_VXPCMDTOOLLIST)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CVXPCmdToolList)
	COM_INTERFACE_ENTRY_IID(CLSID_VXPCmdToolList, CVXPCmdToolList)
	COM_INTERFACE_ENTRY(IVXPCmdToolList)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

public:

	CVXPTooltipManager * m_pManager;

	CToolCmdList * m_pList;

	HRESULT FinalConstruct();
	HRESULT FinalRelease();

// IVXPCmdToolList
public:
	STDMETHOD(get_Size)(/*[out, retval]*/ short *pVal);
	STDMETHOD(SetActive)(/*[in]*/ long CommandID, /*[in]*/ VARIANT_BOOL Active, /*[out, retval]*/ VARIANT_BOOL * success);
	STDMETHOD(Remove)(/*[in]*/ long CommandID, /*[out, retval]*/ VARIANT_BOOL * success);
	STDMETHOD(Modify)(/*[in]*/ long CommandID, /*[in]*/ BSTR ToolTip, /*[out, retval]*/ VARIANT_BOOL * success);
	STDMETHOD(IsActive)(/*[in]*/ long CommandID, /*[out, retval]*/ VARIANT_BOOL * result);
	STDMETHOD(HasTool)(/*[in]*/ long CommandID, /*[out, retval]*/ VARIANT_BOOL * result);
	STDMETHOD(Clear)();
	STDMETHOD(Add)(/*[in]*/ long CommandID, /*[in]*/ BSTR ToolTip);

};

#endif //__VXPCMDTOOLLIST_H_
