/*
 * VXPLib COMPONENT
 *
 * Module: VXPMargins.h - Declaration of class CVXPMargins
 *
 * Synopsis: Class CVXPMargins implements methods and properties
 * of interface IVXPMargins.
 *
 * Copyright (c) 2002, Vitaly Tomilov
 * Copyright (c) 2003-2005, Tooltips.Net L.L.C.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Library support web site - http://www.tooltips.net
 */

#ifndef __VXPMARGINS_H_
#define __VXPMARGINS_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CVXPMargins
class ATL_NO_VTABLE CVXPMargins : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CVXPMargins, &CLSID_VXPMargins>,
	public ISupportErrorInfo,
	public IDispatchImpl<IVXPMargins, &IID_IVXPMargins, &LIBID_VXPLibrary>,
	public CVXPException<&CLSID_VXPMargins, &IID_IVXPMargins>
{
public:
	CVXPMargins();

DECLARE_REGISTRY_RESOURCEID(IDR_VXPMARGINS)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CVXPMargins)
	COM_INTERFACE_ENTRY(IVXPMargins)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

	HRESULT FinalConstruct();
	HRESULT FinalRelease();

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IVXPMargins
public:
	STDMETHOD(SetDefaults)();
	STDMETHOD(AdjustMarginsByMax)(/*[in]*/ short MaxLeft, /*[in]*/ short MaxTop, /*[in]*/ short MaxRight, /*[in]*/ short MaxBottom);
	STDMETHOD(AdjustMarginsByMin)(/*[in]*/ short MinLeft, /*[in]*/ short MinTop, /*[in]*/ short MinRight, /*[in]*/ short MinBottom);
	STDMETHOD(get_Bottom)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_Bottom)(/*[in]*/ short newVal);
	STDMETHOD(get_Right)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_Right)(/*[in]*/ short newVal);
	STDMETHOD(get_Top)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_Top)(/*[in]*/ short newVal);
	STDMETHOD(get_Left)(/*[out, retval]*/ short *pVal);
	STDMETHOD(put_Left)(/*[in]*/ short newVal);

private:
	void SetDefaultParameters();
	short m_nLeft;
	short m_nTop;
	short m_nRight;
	short m_nBottom;
};

#endif //__VXPMARGINS_H_
