/*
 * VXPLib COMPONENT
 *
 * Module: VXPWndToolList.h - Declaration of class CVXPWndToolList
 *
 * Synopsis: Class CVXPWndToolList implements methods and properties
 * of interface IVXPWndToolList.
 *
 * Copyright (c) 2002, Vitaly Tomilov
 * Copyright (c) 2003-2005, Tooltips.Net L.L.C.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Library support web site - http://www.tooltips.net
 */

#ifndef __VXPWNDTOOLLIST_H_
#define __VXPWNDTOOLLIST_H_

#include "resource.h"       // main symbols
#include "ToolList.h"

class CVXPTooltipManager;

/////////////////////////////////////////////////////////////////////////////
// CVXPWndToolList
class ATL_NO_VTABLE CVXPWndToolList : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CVXPWndToolList, &CLSID_VXPWndToolList>,
	public ISupportErrorInfo,
	public IDispatchImpl<IVXPWndToolList, &IID_IVXPWndToolList, &LIBID_VXPLibrary>,
	public CVXPException<&CLSID_VXPWndToolList, &IID_IVXPWndToolList>
{
public:
	CVXPWndToolList()
	{
		m_pManager = NULL;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_VXPWNDTOOLLIST)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CVXPWndToolList)
	COM_INTERFACE_ENTRY_IID(CLSID_VXPWndToolList, CVXPWndToolList)
	COM_INTERFACE_ENTRY(IVXPWndToolList)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

public:

	CVXPTooltipManager * m_pManager;

	CToolWndList * m_pList;

	HRESULT FinalConstruct();
	HRESULT FinalRelease();


// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IVXPWndToolList
public:
	STDMETHOD(get_Size)(/*[out, retval]*/ short *pVal);
	STDMETHOD(SetActive)(/*[in]*/ long hWnd, /*[in]*/ VARIANT_BOOL Active, /*[out, retval]*/ VARIANT_BOOL * success);
	STDMETHOD(IsActive)(/*[in]*/ long hWnd, /*[out, retval]*/ VARIANT_BOOL * result);
	STDMETHOD(HasTool)(/*[in]*/ long hWnd, /*[out, retval]*/ VARIANT_BOOL * result);
	STDMETHOD(Clear)();
	STDMETHOD(Remove)(/*[in]*/ long hWnd, /*[out, retval]*/ VARIANT_BOOL * success);
	STDMETHOD(Modify)(/*[in]*/ long hWnd, /*[in]*/ BSTR ToolTip, /*[out, retval]*/ VARIANT_BOOL * success);
	STDMETHOD(Add)(/*[in]*/ long hWnd, /*[in]*/ BSTR ToolTip);
};

#endif //__VXPWNDTOOLLIST_H_
